std::pair< _T1, _T2 > Struct Template Reference
Utilities

`#include <stl_pair.h>`

Inheritance diagram for std::pair< _T1, _T2 >:
[legend]

## Public Types

template<typename _U1 , typename _U2 >
using | _PCCFP = _PCC<!is_same< _T1, _U1 >::value||!is_same< _T2, _U2 >::value, _T1, _T2 >
using | _PCCP = _PCC< true, _T1, _T2 >
typedef _T1 | first_type
typedef _T2 | second_type

## Public Member Functions

template<typename _U1 = _T1, typename _U2 = _T2, typename enable_if< __and_< __is_implicitly_default_constructible< _U1 >, __is_implicitly_default_constructible< _U2 > > ::value, bool >::type = true>
constexpr | pair ()
template<typename _U1 , typename _U2 , typename enable_if< _PCCP::template _MoveConstructiblePair< _U1, _U2 >() &&_PCCP::template _ImplicitlyMoveConvertiblePair< _U1, _U2 >(), bool >::type = true>
constexpr | pair (_U1 &&__x, _U2 &&__y)
template<typename _U1 , typename _U2 , typename enable_if< _PCCP::template _MoveConstructiblePair< _U1, _U2 >() &&!_PCCP::template _ImplicitlyMoveConvertiblePair< _U1, _U2 >(), bool >::type = false>
constexpr | pair (_U1 &&__x, _U2 &&__y)
template<typename _U1 , typename enable_if< _PCCP::template _MoveCopyPair< true, _U1, _T2 >(), bool >::type = true>
constexpr | pair (_U1 &&__x, const _T2 &__y)
template<typename _U1 , typename enable_if< _PCCP::template _MoveCopyPair< false, _U1, _T2 >(), bool >::type = false>
constexpr | pair (_U1 &&__x, const _T2 &__y)
template<typename _U1 = _T1, typename _U2 = _T2, typename enable_if< _PCCP::template _ConstructiblePair< _U1, _U2 >() &&_PCCP::template _ImplicitlyConvertiblePair< _U1, _U2 >(), bool >::type = true>
constexpr | pair (const _T1 &__a, const _T2 &__b)
template<typename _U1 = _T1, typename _U2 = _T2, typename enable_if< _PCCP::template _ConstructiblePair< _U1, _U2 >() &&!_PCCP::template _ImplicitlyConvertiblePair< _U1, _U2 >(), bool >::type = false>
constexpr | pair (const _T1 &__a, const _T2 &__b)
template<typename _U2 , typename enable_if< _PCCP::template _CopyMovePair< true, _T1, _U2 >(), bool >::type = true>
constexpr | pair (const _T1 &__x, _U2 &&__y)
template<typename _U2 , typename enable_if< _PCCP::template _CopyMovePair< false, _T1, _U2 >(), bool >::type = false>
| pair (const _T1 &__x, _U2 &&__y)
constexpr | pair (const pair &)=default
template<typename _U1 , typename _U2 , typename enable_if< _PCCFP< _U1, _U2 >::template _ConstructiblePair< _U1, _U2 >() &&_PCCFP< _U1, _U2 >::template _ImplicitlyConvertiblePair< _U1, _U2 >(), bool >::type = true>
constexpr | pair (const pair< _U1, _U2 > &__p)
template<typename _U1 , typename _U2 , typename enable_if< _PCCFP< _U1, _U2 >::template _ConstructiblePair< _U1, _U2 >() &&!_PCCFP< _U1, _U2 >::template _ImplicitlyConvertiblePair< _U1, _U2 >(), bool >::type = false>
constexpr | pair (const pair< _U1, _U2 > &__p)
constexpr | pair (pair &&)=default
template<typename _U1 , typename _U2 , typename enable_if< _PCCFP< _U1, _U2 >::template _MoveConstructiblePair< _U1, _U2 >() &&_PCCFP< _U1, _U2 >::template _ImplicitlyMoveConvertiblePair< _U1, _U2 >(), bool >::type = true>
constexpr | pair (pair< _U1, _U2 > &&__p)
template<typename _U1 , typename _U2 , typename enable_if< _PCCFP< _U1, _U2 >::template _MoveConstructiblePair< _U1, _U2 >() &&!_PCCFP< _U1, _U2 >::template _ImplicitlyMoveConvertiblePair< _U1, _U2 >(), bool >::type = false>
constexpr | pair (pair< _U1, _U2 > &&__p)
template<typename... _Args1, typename... _Args2>
| pair (piecewise_construct_t, tuple< _Args1... >, tuple< _Args2... >)
template<typename _U1 , typename _U2 >
enable_if< __and_< is_assignable< _T1 &, const_U1 & >, is_assignable< _T2 &, const_U2 & > >::value, pair & >::type | operator= (const pair< _U1, _U2 > &__p)
template<typename _U1 , typename _U2 >
enable_if< __and_< is_assignable< _T1 &, _U1 && >, is_assignable< _T2 &, _U2 && > >::value, pair & >::type | operator= (pair< _U1, _U2 > &&__p)
pair & | operator= (typename conditional< __and_< is_copy_assignable< _T1 >, is_copy_assignable< _T2 > >::value, const pair &, const __nonesuch_no_braces & >::type __p)
pair & | operator= (typename conditional< __and_< is_move_assignable< _T1 >, is_move_assignable< _T2 > >::value, pair &&, __nonesuch_no_braces && >::type __p) noexcept(__and_< is_nothrow_move_assignable< _T1 >, is_nothrow_move_assignable< _T2 > >::value)
void | swap (pair &__p) noexcept(__and_< __is_nothrow_swappable< _T1 >, __is_nothrow_swappable< _T2 > >::value)

## Public Attributes

_T1 | first
_T2 | second

## Detailed Description

template<typename _T1, typename _T2>
struct std::pair< _T1, _T2 >

Struct holding two objects of arbitrary type.

Template Parameters

  _T1 | Type of first object.
  _T2 | Type of second object.

Definition at line 208 of file stl_pair.h.

## Member Typedef Documentation

## _PCCFP

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 >

using std::pair< _T1, _T2 >::_PCCFP = _PCC<!is_same<_T1, _U1>::value || !is_same<_T2, _U2>::value, _T1, _T2>

There is also a templated copy ctor for the `pair` class itself.

Definition at line 281 of file stl_pair.h.

## _PCCP

template<typename _T1 , typename _T2 >

using std::pair< _T1, _T2 >::_PCCP = _PCC<true, _T1, _T2>

Two objects may be passed to a `pair` constructor to be copied.

Definition at line 252 of file stl_pair.h.

## first_type

template<typename _T1 , typename _T2 >

typedef _T1 std::pair< _T1, _T2 >::first_type

Definition at line 211 of file stl_pair.h.

## second_type

template<typename _T1 , typename _T2 >

typedef _T2 std::pair< _T1, _T2 >::second_type

`first_type` is the first bound type

Definition at line 212 of file stl_pair.h.

## Constructor & Destructor Documentation

## pair() [1/14]

template<typename _T1 , typename _T2 >
template<typename _U1 = _T1, typename _U2 = _T2, typename enable_if< __and_< __is_implicitly_default_constructible< _U1 >, __is_implicitly_default_constructible< _U2 > > ::value, bool >::type = true>

constexpr std::pair< _T1, _T2 >::pair | ( |  | ) |

inline constexpr

`second` is a copy of the second object

The default constructor creates `first` and `second` using their respective default constructors.

Definition at line 229 of file stl_pair.h.

## pair() [2/14]

template<typename _T1 , typename _T2 >
template<typename _U1 = _T1, typename _U2 = _T2, typename enable_if< __and_< is_default_constructible< _U1 >, is_default_constructible< _U2 >, __not_< __and_< __is_implicitly_default_constructible< _U1 >, __is_implicitly_default_constructible< _U2 > > > > ::value, bool >::type = false>

constexpr std::pair< _T1, _T2 >::pair | ( |  | ) |

inline explicit constexpr

Definition at line 242 of file stl_pair.h.

## pair() [3/14]

template<typename _T1 , typename _T2 >
template<typename _U1 = _T1, typename _U2 = _T2, typename enable_if< _PCCP::template _ConstructiblePair< _U1, _U2 >() &&_PCCP::template _ImplicitlyConvertiblePair< _U1, _U2 >(), bool >::type = true>

constexpr std::pair< _T1, _T2 >::pair | ( | const _T1 & | __a,
|  | const _T2 & | __b
| ) |  |

inline constexpr

Definition at line 260 of file stl_pair.h.

## pair() [4/14]

template<typename _T1 , typename _T2 >
template<typename _U1 = _T1, typename _U2 = _T2, typename enable_if< _PCCP::template _ConstructiblePair< _U1, _U2 >() &&!_PCCP::template _ImplicitlyConvertiblePair< _U1, _U2 >(), bool >::type = false>

constexpr std::pair< _T1, _T2 >::pair | ( | const _T1 & | __a,
|  | const _T2 & | __b
| ) |  |

inline explicit constexpr

Definition at line 269 of file stl_pair.h.

## pair() [5/14]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , typename enable_if< _PCCFP< _U1, _U2 >::template _ConstructiblePair< _U1, _U2 >() &&_PCCFP< _U1, _U2 >::template _ImplicitlyConvertiblePair< _U1, _U2 >(), bool >::type = true>

constexpr std::pair< _T1, _T2 >::pair | ( | const pair< _U1, _U2 > & | __p | ) |

inline constexpr

Definition at line 291 of file stl_pair.h.

## pair() [6/14]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , typename enable_if< _PCCFP< _U1, _U2 >::template _ConstructiblePair< _U1, _U2 >() &&!_PCCFP< _U1, _U2 >::template _ImplicitlyConvertiblePair< _U1, _U2 >(), bool >::type = false>

constexpr std::pair< _T1, _T2 >::pair | ( | const pair< _U1, _U2 > & | __p | ) |

inline explicit constexpr

Definition at line 300 of file stl_pair.h.

## pair() [7/14]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename enable_if< _PCCP::template _MoveCopyPair< true, _U1, _T2 >(), bool >::type = true>

constexpr std::pair< _T1, _T2 >::pair | ( | _U1 && | __x,
|  | const _T2 & | __y
| ) |  |

inline constexpr

Definition at line 311 of file stl_pair.h.

## pair() [8/14]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename enable_if< _PCCP::template _MoveCopyPair< false, _U1, _T2 >(), bool >::type = false>

constexpr std::pair< _T1, _T2 >::pair | ( | _U1 && | __x,
|  | const _T2 & | __y
| ) |  |

inline explicit constexpr

Definition at line 318 of file stl_pair.h.

## pair() [9/14]

template<typename _T1 , typename _T2 >
template<typename _U2 , typename enable_if< _PCCP::template _CopyMovePair< true, _T1, _U2 >(), bool >::type = true>

constexpr std::pair< _T1, _T2 >::pair | ( | const _T1 & | __x,
|  | _U2 && | __y
| ) |  |

inline constexpr

Definition at line 325 of file stl_pair.h.

## pair() [10/14]

template<typename _T1 , typename _T2 >
template<typename _U2 , typename enable_if< _PCCP::template _CopyMovePair< false, _T1, _U2 >(), bool >::type = false>

std::pair< _T1, _T2 >::pair | ( | const _T1 & | __x,
|  | _U2 && | __y
| ) |  |

inline explicit

Definition at line 332 of file stl_pair.h.

## pair() [11/14]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , typename enable_if< _PCCP::template _MoveConstructiblePair< _U1, _U2 >() &&_PCCP::template _ImplicitlyMoveConvertiblePair< _U1, _U2 >(), bool >::type = true>

constexpr std::pair< _T1, _T2 >::pair | ( | _U1 && | __x,
|  | _U2 && | __y
| ) |  |

inline constexpr

Definition at line 341 of file stl_pair.h.

## pair() [12/14]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , typename enable_if< _PCCP::template _MoveConstructiblePair< _U1, _U2 >() &&!_PCCP::template _ImplicitlyMoveConvertiblePair< _U1, _U2 >(), bool >::type = false>

constexpr std::pair< _T1, _T2 >::pair | ( | _U1 && | __x,
|  | _U2 && | __y
| ) |  |

inline explicit constexpr

Definition at line 350 of file stl_pair.h.

## pair() [13/14]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , typename enable_if< _PCCFP< _U1, _U2 >::template _MoveConstructiblePair< _U1, _U2 >() &&_PCCFP< _U1, _U2 >::template _ImplicitlyMoveConvertiblePair< _U1, _U2 >(), bool >::type = true>

constexpr std::pair< _T1, _T2 >::pair | ( | pair< _U1, _U2 > && | __p | ) |

inline constexpr

Definition at line 360 of file stl_pair.h.

## pair() [14/14]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , typename enable_if< _PCCFP< _U1, _U2 >::template _MoveConstructiblePair< _U1, _U2 >() &&!_PCCFP< _U1, _U2 >::template _ImplicitlyMoveConvertiblePair< _U1, _U2 >(), bool >::type = false>

constexpr std::pair< _T1, _T2 >::pair | ( | pair< _U1, _U2 > && | __p | ) |

inline explicit constexpr

Definition at line 370 of file stl_pair.h.

## Member Function Documentation

## operator=() [1/4]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 >

enable_if< __and_< is_assignable< _T1 &, const_U1 & >, is_assignable< _T2 &, const_U2 & > >::value, pair & >::type std::pair< _T1, _T2 >::operator= | ( | const pair< _U1, _U2 > & | __p | ) |

inline

Definition at line 405 of file stl_pair.h.

## operator=() [2/4]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 >

enable_if< __and_< is_assignable< _T1 &, _U1 && >, is_assignable< _T2 &, _U2 && > >::value, pair & >::type std::pair< _T1, _T2 >::operator= | ( | pair< _U1, _U2 > && | __p | ) |

inline

Definition at line 416 of file stl_pair.h.

## operator=() [3/4]

template<typename _T1 , typename _T2 >

pair & std::pair< _T1, _T2 >::operator= | ( | typename conditional< __and_< is_copy_assignable< _T1 >, is_copy_assignable< _T2 > >::value, const pair< _T1, _T2 > &, const __nonesuch_no_braces & >::type | __p | ) |

inline

Definition at line 378 of file stl_pair.h.

## operator=() [4/4]

template<typename _T1 , typename _T2 >

pair & std::pair< _T1, _T2 >::operator= | ( | typename conditional< __and_< is_move_assignable< _T1 >, is_move_assignable< _T2 > >::value, pair< _T1, _T2 > &&, __nonesuch_no_braces && >::type | __p | ) |

inline noexcept

Definition at line 389 of file stl_pair.h.

## swap()

template<typename _T1 , typename _T2 >

void std::pair< _T1, _T2 >::swap | ( | pair< _T1, _T2 > & | __p | ) |

inline noexcept

Definition at line 424 of file stl_pair.h.

## Member Data Documentation

## first

template<typename _T1 , typename _T2 >

_T1 std::pair< _T1, _T2 >::first

`second_type` is the second bound type

Definition at line 214 of file stl_pair.h.

## second

template<typename _T1 , typename _T2 >

_T2 std::pair< _T1, _T2 >::second

`first` is a copy of the first object

Definition at line 215 of file stl_pair.h.

The documentation for this struct was generated from the following files:

- stl_pair.h
- tuple